import { CobblerHandler } from './cobbler-handler';
export declare type Record = {
    id: number;
    logicRemove: boolean;
};
export declare type ColumnConfig = {
    type: string;
    needed: boolean;
    default: any;
    reference?: string;
    unique: boolean;
    owner: true;
};
export declare type TableConfig = {
    [key: string]: ColumnConfig;
};
export declare type TablesConfig = {
    [key: string]: TableConfig;
};
export declare function BaseCobbler(path?: string): Cobbler;
export declare class Cobbler {
    private dataPath;
    private tables;
    private handler;
    constructor(dataPath: string, tables: TablesConfig, handler?: CobblerHandler);
    getTables(): {
        tableName: string;
    }[];
    save(name: string, record: Record): any;
    private callInsert;
    remove(name: string, id: number): Record;
    findById(name: string, id: number): Record | null;
    findAll(name: string, parms?: any): Record[];
    columnFilter(name: string, parms: any, record: Record): unknown;
    invokeColumnFilter(name: string, column: ColumnConfig, parms: any, record: Record): boolean;
    findPage(name: string, page: number, size: number, sortName: string, sortDir: 'ASC' | 'DESC', parms: any): {
        count: number;
        items: Record[];
    };
    private transformRecord;
    private collectOwnedReferences;
    private update;
    private insert;
    private validate;
    private checkUnique;
    private checkColumnType;
    private checkReference;
    private locate;
    private readDataFile;
    private writeDataFile;
}
